#include  "soccer_agent_environment.h"
#include  "autogen_act_zeng_df.h"
#include  <iostream>
#include  <cfloat>

using namespace std;

int    main( int  argc ,  char *  argv[] )
{
	//
	// Initialize I/O
	//
	ios::sync_with_stdio();

	cout.precision( DBL_DIG );
	cerr.precision( DBL_DIG );


	//
	// Interpret Option
	//
	Soccer_Option_Analyser	opt( "Zeng01" /* default team name */ ,
				     false    /* default is field player */ );

	if ( ! opt.analyse( argc , argv ) )
	{
		opt.usage();
		return( 1 );
	}
	else if ( opt.help() )
	{
		opt.usage();
		return( 0 );
	}

	//tmp
	srandom(12345) ;
	//
	// Build Agent Environment
	//
	Soccer_Agent_Environment	agent_environment( opt );

	//
	// Make Action
	//
	Act_Zeng_Df::Role_Type	role;
	if ( opt.role() == "+DF" )
	{
		role = Act_Zeng_Df::Positive_Side_DF;
	}
	else if ( opt.role() == "-DF" )
	{
		role = Act_Zeng_Df::Negative_Side_DF;
	}
	else if ( opt.role() == "DF" || opt.role().length() == 0 )
	{
		role = Act_Zeng_Df::Zero_DF;
	}
	else if ( opt.role() == "+CB" )
	{
		role = Act_Zeng_Df::Positive_Side_CB;
	}
	else if ( opt.role() == "-CB" )
	{
		role = Act_Zeng_Df::Negative_Side_CB;
	}
	else if ( opt.role() == "+SB" )
	{
		role = Act_Zeng_Df::Positive_Side_SB;
	}
	else if ( opt.role() == "-SB" )
	{
		role = Act_Zeng_Df::Negative_Side_SB;
	}
	else
	{
		cerr << "Unrecognized Role: \"" << opt.role() << "\""
		     << endl;
		role = Act_Zeng_Df::Zero_DF;
		//return( 1 );
	}

	Act_Zeng_Df	action( agent_environment.field_recog_interface() ,
				role );


	//
	// Main Loop
	//
	while( agent_environment.valid() )
	{
		agent_environment.next_step();

		if ( ! action.finished() )
		{
			agent_environment.send_composite_command
				( action.get_command() );
		}
	}

	return( 0 );
}
