#include  "soccer_agent_environment.h"
#include  "autogen_act_zeng_mf.h"
#include  <iostream>
#include  <cfloat>

using namespace std;

int    main( int  argc ,  char *  argv[] )
{
	//
	// Initialize I/O
	//
	ios::sync_with_stdio();

	cout.precision( DBL_DIG );
	cerr.precision( DBL_DIG );


	//
	// Interpret Option
	//
	Soccer_Option_Analyser	opt( "Zeng01" /* default team name */ ,
				     false    /* default is field player */ );

	if ( ! opt.analyse( argc , argv ) )
	{
		opt.usage();
		return( 1 );
	}
	else if ( opt.help() )
	{
		opt.usage();
		return( 0 );
	}


	//tmp
	srandom(12345) ;
	//
	// Build Agent Environment
	//
	Soccer_Agent_Environment	agent_environment( opt );

	//
	// Make Action
	//
	Act_Zeng_Mf::Role_Type	role;
	if ( opt.role() == "+MF" )
	{
		role = Act_Zeng_Mf::Positive_Side_MF;
	}
	else if ( opt.role() == "-MF" )
	{
		role = Act_Zeng_Mf::Negative_Side_MF;
	}
	else if ( opt.role() == "MF" || opt.role().length() == 0 )
	{
		role = Act_Zeng_Mf::Zero_MF;
	}
	else if ( opt.role() == "+CMF" )
	{
		role = Act_Zeng_Mf::Positive_Side_CMF;
	}
	else if ( opt.role() == "-CMF" )
	{
		role = Act_Zeng_Mf::Negative_Side_CMF;
	}
	else if ( opt.role() == "+SMF" )
	{
		role = Act_Zeng_Mf::Positive_Side_SMF;
	}
	else if ( opt.role() == "-SMF" )
	{
		role = Act_Zeng_Mf::Negative_Side_SMF;
	}
	else if ( opt.role() == "+OSMF" )
	{
		role = Act_Zeng_Mf::Positive_Side_OSMF;
	}
	else if ( opt.role() == "-OSMF" )
	{
		role = Act_Zeng_Mf::Negative_Side_OSMF;
	}
	else if ( opt.role() == "OH" )
	{
		role = Act_Zeng_Mf::Zero_OH;
	}
	else if ( opt.role() == "+OH" )
	{
		role = Act_Zeng_Mf::Positive_Side_OH;
	}
	else if ( opt.role() == "-OH" )
	{
		role = Act_Zeng_Mf::Negative_Side_OH;
	}
	else if ( opt.role() == "OH2" )
	{
		role = Act_Zeng_Mf::Zero_OH2;
	}
	else if ( opt.role() == "+OH2" )
	{
		role = Act_Zeng_Mf::Positive_Side_OH2;
	}
	else if ( opt.role() == "-OH2" )
	{
		role = Act_Zeng_Mf::Negative_Side_OH2;
	}
	else if ( opt.role() == "DH" )
	{
		role = Act_Zeng_Mf::Zero_DH;
	}
	else if ( opt.role() == "+DH" )
	{
		role = Act_Zeng_Mf::Positive_Side_DH;
	}
	else if ( opt.role() == "-DH" )
	{
		role = Act_Zeng_Mf::Negative_Side_DH;
	}
	else
	{
		cerr << "Unrecognized Role: \"" << opt.role() << "\""
		     << endl;
		role = Act_Zeng_Mf::Zero_MF;
		//return( 1 );
	}

	//
	ref_count_ptr<Soccer_Action>	action ;

	//load action
	if ( true )
	{
		action = new Act_Zeng_Mf( agent_environment.field_recog_interface() ,
				 role ) ;
	}

	//
	// Register Action
	//
	agent_environment.set_action( action );


	//
	// Main Loop
	//
	agent_environment.run();

	return( 0 );
}
